/*
# Copyright (C) 2015 audin.
#   2015/01 : Modified for NUCLEO-F411RE
#   http://mpu.seesaa.net
# Copyright (C) 2013 audin.
#   2013/07
#   http://avr.paslog.jp
# This file is licensed under the MIT License.
*/

#include "sys.h"
#include "uart.h"
#include "systick.h"
#include "Scheduler.h"
#include "led_tsk.h"
#include "sio_tsk.h"


#include "system_clock_config.h"


void hardware_init(void)
{
    /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
    HAL_Init();

    /* Configure the system clock */
    SystemClock_Config();

    /* Initialize all configured peripherals */
    MX_GPIO_Init();

    systick_init();
    uart_init(115200);
}

/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  main
 *  Description:  
 * =====================================================================================
 */
int main(void)
{

    hardware_init();

    scheduler_init();
	scheduler_startLoop( led_task );
//	scheduler_startLoop( led2_task );
	scheduler_startLoop( sio_key_input_task );

	sio_task();

	return 0;
}

